uniform float hue;
varying vec2 v_texCoord;

void main() {
    float saturation = 0.8;
    gl_FragColor = texture2D( CC_Texture0, v_texCoord );
    float angle = CC_SinTime.z * 3.14159265;
    float s = sin(angle), c = cos(angle);
    vec3 weights = (vec3(2.0 * c, -sqrt(3.0) * s - c, sqrt(3.0) * s - c) + 1.0) / 3.0;
    float len = length(gl_FragColor.rgb);
    gl_FragColor.rgb = vec3(
        dot(gl_FragColor.rgb, weights.xyz),
        dot(gl_FragColor.rgb, weights.zxy),
        dot(gl_FragColor.rgb, weights.yzx)
    );
    float average = (gl_FragColor.r + gl_FragColor.g + gl_FragColor.b) / 3.0;
    if (saturation > 0.0) {
        gl_FragColor.rgb += (average - gl_FragColor.rgb) * (1.0 - 1.0 / (1.001 - saturation));
    } else {
        gl_FragColor.rgb += (average - gl_FragColor.rgb) * (-saturation);
    }
}
