#ifdef GL_ES
precision mediump float;
#endif

uniform vec2 center;
varying vec2 v_texCoord;
float luma(vec3 color) {
    return dot(color, vec3(0.299, 0.587, 0.114));
}
void main() {
    vec2 resolution = vec2(40.0, 69.0);
    float scale = 1.0;
    vec2 uv = v_texCoord;
    float noiseScale = 10.0;
    float radius = 0.5;
    vec2 d = uv - center;
    float r = length( d * vec2( 1., resolution.y / resolution.x ) ) * scale;
    float a = atan(d.y,d.x) + noiseScale*(radius-r)/radius;
    vec2 uvt = center+r*vec2(cos(a),sin(a));
    vec2 uv2 = v_texCoord;
    float c = ( .75 + .25 * sin( uvt.x * 1000. ) );
    vec4 color = texture2D( CC_Texture0, uv2 );
    float l = luma( color.rgb );
    float f = smoothstep( .5 * c, c, l );
    f = smoothstep( 0., .5, f );
    vec3 col = vec3(f);
    gl_FragColor = vec4( col, color.a);
}
