varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float time;

vec3 rainbow2( in float t ){
    vec3 d = vec3(0.0,0.33,0.67);
    return 0.5 + 0.5*cos( 6.28318*(t+d) );
}

void main() {
    float offset = 0.5;
    float mount = 0.5;
    vec2 p = v_texCoord * 50.0;
    vec4 origCol = texture2D( CC_Texture0, v_texCoord );
    if(origCol.a <= 0.000001)
        discard;
    vec2 off = texture2D( CC_Texture0, v_texCoord ).rg - 0.5;
    p += off * offset;
    vec3 rb = rainbow2( (p.x + p.y + time) * 0.5);
    vec3 col = mix(origCol.rgb,rb,mount);
    gl_FragColor = vec4(col, 1);
}
