#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D u_texture;


vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}


void main(){

    vec4 oriTex = texture2D(CC_Texture0, v_texCoord);
    vec3 hsvTex = rgb2hsv( vec3(oriTex.r , oriTex.g ,oriTex.b ) );

    float h = hsvTex.r + 0.2 ;
    float s = hsvTex.b ;//+ 0.1;
    if ( h > 1.0) h -= 1.0;
    //if ( s > 1.0f) s = 1.0;
    vec3 fixedTex =   hsv2rgb( vec3( h,s,hsvTex.b ) );

    gl_FragColor = vec4( fixedTex.r,fixedTex.g,fixedTex.b,oriTex.a );
    //gl_FragColor = vec4( h,fixedTex.g,fixedTex.b,oriTex.a );

}
